// CHashStr
// http://forlix.org/, df@forlix.org
//
// Copyright (c) 2009-2013 Dominik Friedrichs

#ifndef CHASHSTR_H
#define CHASHSTR_H

#include <string.h>

class CHashStr
{
public:
  const char *Read(const char *Key,
                   char *Value, size_t ValueLen);
  const char *Read(const char *Key);

  bool Write(const char *Key,
             const char *Value);

  bool Delete(const char *Key);

  bool LoopThroughKeys(char *&Key,
                       char *&Value,
                       unsigned long *BucketIterator,
                       void *&NodeIterator);

  unsigned long TellCollisions(void);
  void Wipe(void);

  CHashStr(unsigned long TableSize);
  ~CHashStr(void);

private:
  static unsigned long Bucket(const char *key,
                              unsigned long tsize);

  typedef
  struct HashNd
  {
    char *Key;
    char *Value;
    HashNd *Link;
  }
  HashNd;

  unsigned long Size;
  HashNd **Table;
};

#endif // CHASHSTR_H
