// CStrBuf
// http://forlix.org/, df@forlix.org
//
// Copyright (c) 2012-2013 Dominik Friedrichs

#include "CStrBuf.h"


CStrBuf::CStrBuf(unsigned long InitSize)
{
  if(InitSize < 2)
    InitSize = 2;

  InitialSize = InitSize;
  Allocated = InitSize;
  Occupied = 0;

  Buffer = new char[Allocated];
  Buffer[0] = '\0';
}


CStrBuf::~CStrBuf(void)
{
  delete [] Buffer;
}


const char *CStrBuf::Read(void)
{
  return(Buffer);
}


void CStrBuf::Append(const char *String)
{
  unsigned long apnd_length = strlen(String);
  unsigned long required = Occupied + apnd_length + 1;

  if(required > Allocated)
  // string needs to grow
  {
    while(Allocated < required)
    // exponential growth
      Allocated = (unsigned long)(Allocated * 1.5);

    char *tmp = new char[Allocated];

    // copy contents from old allocation
    strcpy(tmp, Buffer);

    delete [] Buffer;
    Buffer = tmp;
  }

  // append new string
  strcpy(&Buffer[Occupied], String);
  Occupied += apnd_length;

  return;
}


void CStrBuf::Wipe(void)
{
  Allocated = InitialSize;
  Occupied = 0;

  delete [] Buffer;

  Buffer = new char[Allocated];
  Buffer[0] = '\0';

  return;
}
