// Forlix SrcDS Manager
// http://forlix.org/, df@forlix.org
//
// Copyright (c) 2010-2013 Dominik Friedrichs

#include "SrcDS_Manager.h"

#define INVALID_FILE_ATTRIBUTES ((DWORD)-1)


bool HasProcessTerminated(HANDLE hProcess)
{
  DWORD exitcode;
  GetExitCodeProcess(hProcess, &exitcode);

  if(exitcode != STILL_ACTIVE)
    return(true);

  return(false);
}


bool FileExists(const char *path)
{
  DWORD attr = GetFileAttributes(path);

  if(attr == INVALID_FILE_ATTRIBUTES
  || (attr & FILE_ATTRIBUTE_DIRECTORY))
    return(false);

  return(true);
}


bool FolderExists(const char *path)
{
  DWORD attr = GetFileAttributes(path);

  if(attr == INVALID_FILE_ATTRIBUTES
  || !(attr & FILE_ATTRIBUTE_DIRECTORY))
    return(false);

  return(true);
}


bool GetFileDirectory(char *directory,
                      const char *path)
{
  directory[0] = '\0';

  const char *lpos = NULL;
  const char *c = path;

  while(*c)
  {
    if(*c == '/'
    || *c == '\\')
      lpos = c;

    c++;
  }

  if(!lpos
  || lpos == c-1)
    return(false);

  size_t dlen = lpos-path+1;
  strncpy(directory, path, dlen);
  directory[dlen] = '\0';
  return(true);
}
